#include <vdi.h>
#include <aes.h>
#include <string.h>     
#include <stdlib.h>     

/*** changeable parameters ***/

#define MAX_FONTS     4000  /* maximum number of GDOS fonts that can be 
                               managed by this module */
#define COLUMNS          2  /* number of font columns */
#define FONTS_PER_PAGE 100  /* must be dividable through COLUMNS */

/*** constants ***/

#define RC               2  /* absolute coordinates */


typedef struct 
{ 
	int font_id ; 
	char font_name[17] ; 
}
FONT_INFO ; 


/*** VDI handle and parameters of physical printer workstation ***/
static int print_handle ;  
static int print_in[11] ;
static int print_out[57] ;
static int number_print_fonts ;
static FONT_INFO print_font_info[MAX_FONTS] ;


int main()
{
int number_pages, i, j, dy, fonts_printed, fonts_on_this_page, dum ;
char text[220], dummy[10] ;
unsigned long id ;

/*** greeting message ***/
	form_alert(1, "[0][   GDOSLIST V0.1| |  by the Mad Harry    |    Munich 1995| ][  OK  ]") ;
/*** open printer workstation and load fonts ***/
	if ( vq_gdos() )
	{
	/*** open physical workstation for the printer ***/
		print_in[0] = 21 ; /* first printer driver of assign.sys */
		for ( i = 1 ; i <= 8 ; i++ ) print_in[i] = 1 ; 
		print_in[9] = 0 ; print_in[10] = RC ; 
		v_opnwk(print_in, &print_handle, print_out) ;
		if (print_handle != 0)
		{
		/*** load printer fonts ***/
			number_print_fonts = print_out[10] + vst_load_fonts(print_handle, 0) ;
			if ( number_print_fonts > MAX_FONTS ) number_print_fonts = MAX_FONTS ;
			for ( i = 0 ; i < number_print_fonts ; i++ )
			{
				print_font_info[i].font_id = vqt_name(print_handle, i + 1, text) ;
				text[16] = '\0' ;
				strcpy(print_font_info[i].font_name, text) ;
			}
		}
		else 
		{
			form_alert(1, "[3][Unable to open |VDI workstation |for the printer. ][ CANCEL ]") ;
			return -1 ;
		}
	}
	else 
	{
		form_alert(1, "[3][GDOS not |installed. ][ CANCEL ]") ;
		return -1 ;
	}
/*** ask if user is ready ***/
	number_pages = number_print_fonts/FONTS_PER_PAGE + 1 ;
	strcpy(text, "[2][Ready to put out a demo with |") ;
	strncat(text, itoa(number_print_fonts, dummy, 10), 4) ;
	strncat(text, " fonts and |", 20) ;
	strncat(text, itoa(number_pages, dummy, 10), 2) ;
	strncat(text, " pages |on your printer ? ][   OK   | CANCEL ]", 100) ;
	if (form_alert(1, text) == 1)
	{
		dy = print_out[1] / FONTS_PER_PAGE * COLUMNS ; /* line distance */
		vst_alignment(print_handle, 0, 5, &dum, &dum) ;
		vst_height(print_handle, dy * 3/4, &dum, &dum, &dum, &dum) ;
		fonts_printed = 1 ; /* ignore system font */
		for ( i = 0 ; i < number_pages ; i++ )
		{
			fonts_on_this_page = 1 ; /* ignore system font */
			while ((fonts_printed < number_print_fonts) 
			       && (fonts_on_this_page < FONTS_PER_PAGE))
			{
				for ( j = 0 ; j < COLUMNS ; j++)
				{
					if (fonts_printed < number_print_fonts)
					{
						vst_font(print_handle, print_font_info[fonts_printed].font_id) ;
						id = 0x0000FFFF & print_font_info[fonts_printed].font_id ;
						ultoa(id, text, 10) ;
						strncat(text, ": ", 30) ;
						strncat(text, print_font_info[fonts_printed].font_name, 30) ; 
						v_gtext(print_handle, 
						        print_out[0] * j / COLUMNS,
						        dy * ( (fonts_on_this_page - 1) / COLUMNS ),
						        text) ;
						fonts_printed++ ; fonts_on_this_page++ ;
					}
				}
			}
		v_updwk(print_handle) ;
		v_clrwk(print_handle) ;
		}
	}
/*** close physical workstation of the printer ***/
	if (print_out[10] < number_print_fonts) 
		vst_unload_fonts(print_handle, 0) ;	
/*** return success ***/
	return 0 ;
}